umbrello 2.39.2 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

- Main Page
- Related Pages
- Topics
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
UMLDatatype Class Reference

Non-graphical information for a Datatype. More...

`#include <datatype.h>`

Inheritance diagram for UMLDatatype:

## Public Member Functions
| UMLDatatype (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLDatatype ()
void | setOriginType (UMLClassifier *origType)
UMLClassifier * | originType () const
void | setIsReference (bool isRef=true)
bool | isReference () const
void | setActive (bool active=true)
bool | isActive () const
virtual bool | load1 (QDomElement &element)
virtual void | saveToXMI (QXmlStreamWriter &writer)
Public Member Functions inherited from UMLClassifier
| UMLClassifier (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLClassifier ()
virtual void | copyInto (UMLObject *lhs) const
UMLObject * | clone () const
virtual void | setNameCmd (const QString &strName)
virtual UMLAttribute * | createAttribute (const QString &name=QString(), UMLObject *type=0, Uml::Visibility::Enum vis=Uml::Visibility::Private, const QString &init=QString())
UMLAttribute * | addAttribute (const QString &name, Uml::ID::Type id=Uml::ID::None)
UMLAttribute * | addAttribute (const QString &name, UMLObject *type, Uml::Visibility::Enum scope)
bool | addAttribute (UMLAttribute *att, IDChangeLog *log=0, int position=-1)
int | removeAttribute (UMLAttribute *att)
UMLAttributeList | getAttributeList () const
UMLAttributeList | getAttributeList (Uml::Visibility::Enum scope) const
UMLAttributeList | getAttributeListStatic (Uml::Visibility::Enum scope) const
UMLOperation * | createOperation (const QString &name=QString(), bool *isExistingOp=0, Model_Utils::NameAndType_List *params=0)
bool | addOperation (UMLOperation *op, int position=-1)
bool | addOperation (UMLOperation *op, IDChangeLog *log)
UMLOperation * | checkOperationSignature (const QString &name, UMLAttributeList opParams, UMLOperation *exemptOp=0) const
int | removeOperation (UMLOperation *op)
int | operations () const
UMLOperationList | getOpList (bool includeInherited=false, UMLClassifierSet *alreadyTraversed=0) const
UMLObject * | createTemplate (const QString &name=QString())
UMLTemplate * | addTemplate (const QString &name, Uml::ID::Type id=Uml::ID::None)
bool | addTemplate (UMLTemplate *newTemplate, IDChangeLog *log=0)
bool | addTemplate (UMLTemplate *templt, int position)
int | removeTemplate (UMLTemplate *umltemplate)
UMLTemplate * | findTemplate (const QString &name) const
int | templates () const
UMLTemplateList | getTemplateList () const
int | takeItem (UMLClassifierListItem *item)
virtual UMLClassifierListItemList | getFilteredList (UMLObject::ObjectType ot) const
virtual bool | resolveRef ()
UMLOperationList | findOperations (const QString &n) const
virtual UMLObject * | findChildObjectById (Uml::ID::Type id, bool considerAncestors=false) const
UMLOperation * | findOperation (const QString &name, Model_Utils::NameAndType_List params) const
UMLClassifierList | findSuperClassConcepts (ClassifierType type=ALL) const
UMLClassifierList | findSubClassConcepts (ClassifierType type=ALL) const
virtual bool | acceptAssociationType (Uml::AssociationType::Enum type) const
void | setBaseType (UMLObject::ObjectType ot)
bool | isInterface () const
bool | hasAbstractOps () const
bool | hasAssociations () const
bool | hasAttributes () const
bool | hasStaticAttributes () const
bool | hasMethods () const
bool | hasAccessorMethods () const
bool | hasOperationMethods () const
bool | hasVectorFields () const
virtual UMLClassifierListItem * | makeChildObject (const QString &xmiTag)
void | removeObject (UMLObject *pObject)
virtual UMLAssociationList | getUniAssociationToBeImplemented () const
Public Member Functions inherited from UMLPackage
| UMLPackage (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLPackage ()
bool | addObject (UMLObject *pObject, bool interactOnConflict=true)
virtual void | removeAllObjects ()
UMLObjectList | containedObjects (bool includeInactive=false) const
void | addAssocToConcepts (UMLAssociation *assoc)
void | removeAssocFromConcepts (UMLAssociation *assoc)
UMLObject * | findObject (const QString &name) const
UMLObject * | findObjectById (Uml::ID::Type id) const
void | appendPackages (UMLPackageList &packages, bool includeNested=true) const
void | appendClassifiers (UMLClassifierList &classifiers, bool includeNested=true) const
void | appendClassesAndInterfaces (UMLClassifierList &classifiers, bool includeNested=true) const
void | appendEntities (UMLEntityList &entities, bool includeNested=true) const
Public Member Functions inherited from UMLCanvasObject
| UMLCanvasObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLCanvasObject ()
bool | operator== (const UMLCanvasObject &rhs) const
bool | addAssociationEnd (UMLAssociation *assoc)
bool | hasAssociation (UMLAssociation *assoc) const
int | removeAssociationEnd (UMLAssociation *assoc)
void | removeAllAssociationEnds ()
int | associations () const
UMLAssociationList | getAssociations () const
UMLAssociationList | getSpecificAssocs (Uml::AssociationType::Enum assocType) const
UMLClassifierList | getSuperClasses (bool withRealizations=true) const
UMLClassifierList | getSubClasses () const
virtual UMLAssociationList | getRealizations () const
UMLAssociationList | getAggregations () const
UMLAssociationList | getCompositions () const
UMLAssociationList | getRelationships () const
virtual UMLObject * | findChildObject (const QString &n, UMLObject::ObjectType t=UMLObject::ot_UMLObject) const
virtual QString | uniqChildName (const UMLObject::ObjectType type, const QString &prefix=QString()) const
virtual void | removeAllChildObjects ()
UMLObjectList & | subordinates () const
Public Member Functions inherited from UMLObject
| UMLObject (const UMLObject &other)
| UMLObject (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLObject (UMLObject *parent)
| UMLObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLObject ()
bool | operator== (const UMLObject &rhs) const
ObjectType | baseType () const
QLatin1String | baseTypeStr () const
virtual void | setID (Uml::ID::Type NewID)
virtual Uml::ID::Type | id () const
QString | doc () const
bool | hasDoc () const
void | setDoc (const QString &d)
void | setVisibility (Uml::Visibility::Enum visibility)
void | setVisibilityCmd (Uml::Visibility::Enum visibility)
Uml::Visibility::Enum | visibility () const
void | setStereotype (const QString &_name)
void | setStereotypeCmd (const QString &_name)
QString | stereotype (bool includeAdornments=false) const
void | setUMLStereotype (UMLStereotype *stereo)
UMLStereotype * | umlStereotype () const
QStringList & | tags ()
QString | package (const QString &separator=QString(), bool includeRoot=false) const
UMLPackageList | packages (bool includeRoot=false) const
bool | setUMLPackage (UMLPackage *pPkg)
UMLPackage * | umlPackage () const
void | setUMLParent (UMLObject *parent)
UMLObject * | umlParent () const
virtual void | setName (const QString &strName)
QString | name () const
virtual QString | fullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
void | setAbstract (bool bAbstract)
bool | isAbstract () const
virtual bool | showPropertiesDialog (QWidget *parent=0)
virtual bool | loadFromXMI (QDomElement &element)
bool | loadStereotype (QDomElement &element)
void | setStatic (bool bStatic)
bool | isStatic () const
void | setSecondaryId (const QString &id)
QString | secondaryId () const
void | setSecondaryFallback (const QString &id)
QString | secondaryFallback () const
void | save1 (QXmlStreamWriter &writer, const QString &type, const QString &tag=QString())
bool | isUMLActor () const
bool | isUMLArtifact () const
bool | isUMLAssociation () const
bool | isUMLAttribute () const
bool | isUMLCategory () const
bool | isUMLCheckConstraint () const
bool | isUMLClassifier () const
bool | isUMLComponent () const
bool | isUMLDatatype () const
bool | isUMLEntity () const
bool | isUMLEntityAttribute () const
bool | isUMLEntityConstraint () const
bool | isUMLEnum () const
bool | isUMLEnumLiteral () const
bool | isUMLFolder () const
bool | isUMLForeignKeyConstraint () const
bool | isUMLInstance () const
bool | isUMLInstanceAttribute () const
bool | isUMLNode () const
bool | isUMLObject () const
bool | isUMLOperation () const
bool | isUMLPackage () const
bool | isUMLPort () const
bool | isUMLRole () const
bool | isUMLStereotype () const
bool | isUMLTemplate () const
bool | isUMLUniqueConstraint () const
bool | isUMLUseCase () const
UMLActor * | asUMLActor ()
UMLArtifact * | asUMLArtifact ()
UMLAssociation * | asUMLAssociation ()
UMLAttribute * | asUMLAttribute ()
UMLCanvasObject * | asUMLCanvasObject ()
UMLCategory * | asUMLCategory ()
UMLCheckConstraint * | asUMLCheckConstraint ()
UMLClassifier * | asUMLClassifier ()
UMLClassifierListItem * | asUMLClassifierListItem ()
UMLClassifierSet * | asUMLClassifierSet ()
UMLComponent * | asUMLComponent ()
UMLDatatype * | asUMLDatatype ()
UMLEntity * | asUMLEntity ()
UMLEntityAttribute * | asUMLEntityAttribute ()
UMLEntityConstraint * | asUMLEntityConstraint ()
UMLEnum * | asUMLEnum ()
UMLEnumLiteral * | asUMLEnumLiteral ()
UMLFolder * | asUMLFolder ()
UMLForeignKeyConstraint * | asUMLForeignKeyConstraint ()
UMLInstance * | asUMLInstance ()
UMLInstanceAttribute * | asUMLInstanceAttribute ()
UMLNode * | asUMLNode ()
UMLObject * | asUMLObject ()
UMLOperation * | asUMLOperation ()
UMLPackage * | asUMLPackage ()
UMLPort * | asUMLPort ()
UMLRole * | asUMLRole ()
UMLStereotype * | asUMLStereotype ()
UMLTemplate * | asUMLTemplate ()
UMLUniqueConstraint * | asUMLUniqueConstraint ()
UMLUseCase * | asUMLUseCase ()
const UMLActor * | asUMLActor () const
const UMLArtifact * | asUMLArtifact () const
const UMLAssociation * | asUMLAssociation () const
const UMLAttribute * | asUMLAttribute () const
const UMLCanvasObject * | asUMLCanvasObject () const
const UMLCategory * | asUMLCategory () const
const UMLCheckConstraint * | asUMLCheckConstraint () const
const UMLClassifier * | asUMLClassifier () const
const UMLClassifierListItem * | asUMLClassifierListItem () const
const UMLClassifierSet * | asUMLClassifierSet () const
const UMLComponent * | asUMLComponent () const
const UMLDatatype * | asUMLDatatype () const
const UMLEntity * | asUMLEntity () const
const UMLEntityAttribute * | asUMLEntityAttribute () const
const UMLEntityConstraint * | asUMLEntityConstraint () const
const UMLEnum * | asUMLEnum () const
const UMLEnumLiteral * | asUMLEnumLiteral () const
const UMLFolder * | asUMLFolder () const
const UMLForeignKeyConstraint * | asUMLForeignKeyConstraint () const
const UMLInstance * | asUMLInstance () const
const UMLInstanceAttribute * | asUMLInstanceAttribute () const
const UMLNode * | asUMLNode () const
const UMLObject * | asUMLObject () const
const UMLOperation * | asUMLOperation () const
const UMLPackage * | asUMLPackage () const
const UMLPort * | asUMLPort () const
const UMLRole * | asUMLRole () const
const UMLStereotype * | asUMLStereotype () const
const UMLTemplate * | asUMLTemplate () const
const UMLUniqueConstraint * | asUMLUniqueConstraint () const
const UMLUseCase * | asUMLUseCase () const

## Protected Attributes
bool | m_isRef
bool | m_isActive
Protected Attributes inherited from UMLPackage
UMLObjectList | m_objects
Protected Attributes inherited from UMLObject
Uml::ID::Type | m_nId
| object's id
QString | m_Doc
| object's documentation
QPointer< UMLStereotype > | m_pStereotype
| stereotype of the object if applicable
QString | m_name
| objects name
ObjectType | m_BaseType
| objects type
Uml::Visibility::Enum | m_visibility
| objects visibility
bool | m_bAbstract
| state of whether the object is abstract or not
bool | m_bStatic
| flag for instance scope
bool | m_bCreationWasSignalled
| auxiliary to maybeSignalObjectCreated()
QPointer< UMLObject > | m_pSecondary
QString | m_SecondaryId
QString | m_SecondaryFallback
QStringList | m_TaggedValues
UMLObjectPrivate * | m_d
| private data

## Additional Inherited Members
Public Types inherited from UMLClassifier
enum | ClassifierType { ALL = 0 , CLASS , INTERFACE , DATATYPE }
Public Types inherited from UMLObject
enum | ObjectType { ot_Unknown = -1 , ot_UMLObject = 100 , ot_Actor , ot_UseCase , ot_Package , ot_Interface , ot_Datatype , ot_Enum , ot_Class , ot_Instance , ot_Association , ot_Attribute , ot_Operation , ot_EnumLiteral , ot_Template , ot_Component , ot_Artifact , ot_Node , ot_Stereotype , ot_Role , ot_Entity , ot_EntityAttribute , ot_Folder , ot_EntityConstraint , ot_UniqueConstraint , ot_ForeignKeyConstraint , ot_CheckConstraint , ot_Category , ot_Port , ot_InstanceAttribute , ot_SubSystem }
Public Slots inherited from UMLObject
void | emitModified ()
Signals inherited from UMLClassifier
void | operationAdded (UMLClassifierListItem *)
void | operationRemoved (UMLClassifierListItem *)
void | templateAdded (UMLClassifierListItem *)
void | templateRemoved (UMLClassifierListItem *)
void | attributeAdded (UMLClassifierListItem *)
void | attributeRemoved (UMLClassifierListItem *)
Signals inherited from UMLCanvasObject
void | sigAssociationEndAdded (UMLAssociation *assoc)
void | sigAssociationEndRemoved (UMLAssociation *assoc)
Signals inherited from UMLObject
void | modified ()
Static Public Member Functions inherited from UMLObject
static QString | toString (ObjectType ot)
static QString | toI18nString (ObjectType t)
static Icon_Utils::IconType | toIcon (ObjectType t)
Protected Member Functions inherited from UMLObject
void | init ()
void | maybeSignalObjectCreated ()
void | save1end (QXmlStreamWriter &writer)

## Detailed Description

Non-graphical information for a Datatype.

This class contains the non-graphical information required for a UML Datatype. This class inherits from UMLClassifier which contains most of the information.

See also
  UMLClassifier Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ UMLDatatype()

UMLDatatype::UMLDatatype | ( | const QString & | name = QString(),
|  | Uml::ID::Type | id = Uml::ID::None )

Sets up a Datatype.

Parameters

  name | The name of the Datatype.
  id | The unique id of the Concept.

## ◆ ~UMLDatatype()

UMLDatatype::~UMLDatatype | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ isActive()

bool UMLDatatype::isActive | ( |  | ) | const

Get the m_isActive flag.

Returns
  true if is active, otherwise false

## ◆ isReference()

bool UMLDatatype::isReference | ( |  | ) | const

Get the m_isRef flag.

Returns
  true if is reference, otherwise false

## ◆ load1()

bool UMLDatatype::load1 | ( | QDomElement & | element | ) |
| virtual

Loads Datatype specific attributes from QDomElement. Is invoked by UMLObject::loadFromXMI() which does most of the work.

Parameters

  element | A QDomElement which contains xml info for this object.

Reimplemented from UMLClassifier.

## ◆ originType()

UMLClassifier * UMLDatatype::originType | ( |  | ) | const

Get the origin type (in case of e.g. typedef)

Returns
  the origin type

## ◆ saveToXMI()

void UMLDatatype::saveToXMI | ( | QXmlStreamWriter & | writer | ) |
| virtual

Creates the UML:Datatype XMI element. Invokes UMLObject::save1() which does most of the work.

Parameters

  writer | the QXmlStreamWriter to save to

Reimplemented from UMLClassifier.

## ◆ setActive()

void UMLDatatype::setActive | ( | bool | active = true | ) |

Set the m_isActive flag (is already set true by constructor).

Parameters

  active | the flag to set

## ◆ setIsReference()

void UMLDatatype::setIsReference | ( | bool | isRef = true | ) |

Set the m_isRef flag (true when dealing with a pointer type)

Parameters

  isRef | the flag to set

## ◆ setOriginType()

void UMLDatatype::setOriginType | ( | UMLClassifier * | origType | ) |

Set the origin type (in case of e.g. typedef)

Parameters

  origType | the origin type to set

## Member Data Documentation

## ◆ m_isActive

bool UMLDatatype::m_isActive
| protected

## ◆ m_isRef

bool UMLDatatype::m_isRef
| protected

The documentation for this class was generated from the following files:

- umbrello/umlmodel/datatype.h
- umbrello/umlmodel/datatype.cpp